SamplePerson_Class:
    type: data
    class:
        methods:
            constructor:
                definitions: firstName[ElementTag(String)]|lastName[ElementTag(String)]
                script:

                - define ***fName <[firstName]>
                - define ***lName <[lastName]>

            ~**GetFullName:
                script:
                - determine <element[<[***fName]> <[***lName]>]>


SampleStudent_Class:
    type: data
    class:
        extends: SamplePerson_Class
        attributes:
            maxAge: 18
            maxGrade: 12
        methods:
            constructor:
                definitions: firstName|lastName|age[ElementTag(Integer)]|yearOfStudy[ElementTag(Integer)]
                script:
                # If the correct parameters are passed in or defined in the child class' constr.
                # method then they are implicitly passed to the parent class' constructor method.

                - define **age <[age]>
                - define **year <[yearOfStudy]>

                - run Method def.call:<queue>.**self.~**GetFullName save:fullName
                - narrate <entry[fullName].created_queue.determination.get[1]>

            GetAge:
                script:
                - determine <[**age]>

            GetGrade:
                script:
                - determine <[**year]>

            SetAge:
                definitions: newAge[ElementTag(Integer)]
                script:
                - if <[newAge]> > <[^maxAge]>:
                    - narrate <element[Error! Cannot set student age higher than maxAge, which is: <[^maxAge]>]>

                - else:
                    - define **age <[newAge]>

            SetGrade:
                definitions: newGrade[ElementTag(Integer)]
                script:
                - if <[newGrade]> > <[^maxGrade]>:
                    - narrate <element[Error! Cannot set student grade higher than maxGrade, which is: <[^maxGrade]>]>

                - else:
                    - define **year <[newGrade]>


TestInheritence:
    type: task
    debug: false
    script:
    - run Object def.queue:<queue> def.object:student1 def.class:SampleStudent_Class def.firstName:John def.lastName:Doe def.age:14 def.yearOfStudy:8

    - run flagvisualizer def.flag:<queue.flag[dclasses.student1].proc[decodeclass]>

    # - run Object def.queue:<queue> def.object:person1 def.class:SamplePerson_Class def.firstName:Jane def.lastName:Doe
    # - run Method def.queue:<queue> def.object:person1 def.method:~*GetFullName

    # - run Method def.queue:<queue> def.object:student1 def.method:GetFullName save:fullName
    # - narrate <entry[fullName].created_queue.determination.get[1]>

    - run Method def.queue:<queue> def.object:student1 def.method:GetAge save:age
    - narrate OLD_AGE:<entry[age].created_queue.determination.get[1]>

    - run Method def.queue:<queue> def.object:student1 def.method:SetAge def.newAge:16

    - run Method def.queue:<queue> def.object:student1 def.method:GetAge save:age
    - narrate NEW_AGE:<entry[age].created_queue.determination.get[1]>
